package com.bjsxt.web.filter;

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.net.http.HttpRequest;

/**
 * 判断当前客户端浏览器是否登录的Filter
 */
@WebFilter(urlPatterns = {"*.do","*.jsp"})
public class UserLoginFilter implements Filter {
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void destroy() {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest req = (HttpServletRequest) servletRequest;
        String uri = req.getRequestURI();
        if(uri.indexOf("login.do") != -1 || uri.indexOf("login.jsp") != -1 || uri.indexOf("validateCode.do") != -1){
            filterChain.doFilter(servletRequest, servletResponse);
        }else{
            HttpSession session = req.getSession();
            Users user = (Users) session.getAttribute(Constants.USER_SESSION_KEY);
            if(user != null){
                filterChain.doFilter(servletRequest, servletResponse);
            }else{
                req.setAttribute(Constants.REQUEST_MSG,"不登录不好使!!!");
                req.getRequestDispatcher("login.jsp").forward(servletRequest,servletResponse);
            }
        }
    }
}
