package com.bjsxt.web.listener;
/**
 * 解决HttpSession被反复销毁的问题
 */

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

public class HttpSessionLifecycleListener implements HttpSessionListener {
    @Override
    public void sessionCreated(HttpSessionEvent se) {

    }

    @Override
    public void sessionDestroyed(HttpSessionEvent se) {
        //获取 ServletContext 对象，然后将所对应的 HttpSession 删除掉
        HttpSession session = se.getSession();
        ServletContext context = session.getServletContext();
        Users user = (Users) session.getAttribute(Constants.USER_SESSION_KEY);
        context.removeAttribute(user.getUserid() + "");
        if(context.getAttribute(user.getUserid() + "") != null){
            System.out.println("不为空");
        }else{
            System.out.println("为空");
        }
    }
}
