package com.bjsxt.web.servlet;

import com.bjsxt.commons.Constants;
import com.bjsxt.exception.UserNotFoundException;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserLoginService;
import com.bjsxt.service.iml.UserLoginServericeImpl;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
@WebServlet("/login.do")
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String username = req.getParameter("username");
        String userpwd = req.getParameter("pwd");
        String code = req.getParameter("code");
        try{

            HttpSession httpSession = req.getSession();
            String codeTemp = (String)httpSession.getAttribute(Constants.VALIDATE_CODE_KEY);
            System.out.println(code);
            System.out.println(codeTemp);
            if(code.equals(codeTemp)){
                UserLoginService userLoginService = new UserLoginServericeImpl();
                Users user = userLoginService.userLogin(username,userpwd);
                //建立客户端与服务端的会话状态
                httpSession.setAttribute(Constants.USER_SESSION_KEY,user);
                //ServletContext对象是全局对象，所有的Servlet共享该对象，所以将HttpSession存放在该对象中
                ServletContext servletContext = this.getServletContext();
                //根据ServletContext中的Key值取出所对应的value，如果没有则为null
                HttpSession temp = (HttpSession) servletContext.getAttribute(user.getUserid() + "");
                //如果在ServletContext中取出来的数据不为空，则说明浏览在客户端器中登陆过
                if(temp != null){
                    //删除ServletContext中Key值所对应的HttpSession对象
                    servletContext.removeAttribute(user.getUserid() + "");
                    //将取出来的这个HttpSession对象销毁
                    temp.invalidate();
                }
                //将最后一次登陆的HttpSession存放在ServletContext对象中
                servletContext.setAttribute(user.getUserid() + "",httpSession);


                //重定向到主页面
                resp.sendRedirect("main.jsp");
            }else{
                req.setAttribute(Constants.REQUEST_MSG,"验证码错误");
                req.getRequestDispatcher("login.jsp").forward(req,resp);
            }


        }catch(UserNotFoundException userNotFoundException){
            req.setAttribute("msg",userNotFoundException.getMessage());
            req.getRequestDispatcher("login.jsp").forward(req,resp);
        }catch(Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }

    }
}
